"use strict";
/*----------------------------------
- DEPENDANCES
----------------------------------*/
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.validate = void 0;
// Node.js
var request_1 = __importDefault(require("request"));
// Internal
var validate_1 = __importDefault(require("./validate"));
var validate_2 = require("./validate");
__createBinding(exports, validate_2, "default", "validate");
/*----------------------------------
- SCRAPER
----------------------------------*/
var Scraper = /** @class */ (function () {
    function Scraper(apiKey) {
        this.apiKey = apiKey;
    }
    Scraper.prototype.scrape = function (requests) {
        var _this = this;
        return new Promise(function (resolve, reject) { return (0, request_1["default"])({
            method: 'POST',
            url: 'https://fast-and-undetectable-scraping-proxy.p.rapidapi.com',
            headers: {
                'content-type': 'application/json',
                'x-rapidapi-host': 'fast-and-undetectable-scraping-proxy.p.rapidapi.com',
                'x-rapidapi-key': _this.apiKey
            },
            body: {
                requests: (0, validate_1["default"])(requests)
            },
            json: true
        }, function (error, response, body) {
            if (error) {
                reject(error);
                return;
            }
            resolve(body);
        }); });
    };
    Scraper.prototype.get = function (url, options, extract) {
        return this.scrape([__assign({ method: 'GET', url: url, extract: extract }, options)]).then(function (res) { return res[0]; });
    };
    Scraper.prototype.post = function (url, body, bodyType, options, extract) {
        return this.scrape([__assign({ method: 'POST', url: url, extract: extract, body: body, bodyType: bodyType }, options)]).then(function (res) { return res[0]; });
    };
    return Scraper;
}());
exports["default"] = Scraper;
module.exports = function (apiKey) { return new Scraper(apiKey); };
