export declare const allowedMethods: string[];
export declare const bodyTypes: string[];
export declare type TRequestWithExtractors = TRequest & {
    extract?: TExtractor;
    withBody?: boolean;
    withHeaders?: boolean;
};
export declare type TRequest = TBasicRequest | TRequestWithBody;
export declare type TBasicRequest = {
    url: string;
    method?: HttpMethod;
    cookies?: string;
};
export declare type TRequestWithBody = TBasicRequest & {
    body: {
        [key: string]: any;
    };
    bodyType: typeof bodyTypes[number];
};
export declare type HttpMethod = typeof allowedMethods[number];
export declare type TExtractor = TValueExtractor | TItemsExtractor;
export declare type TValueExtractor = [
    selector: "this" | string,
    attribute: "text" | "html" | string,
    required: boolean,
    ...filters: string[]
];
export declare type TItemsExtractor = ({
    $foreach?: string;
} & {
    [name: string]: TExtractor;
});
export declare type TScrapeResult<TData extends any = any> = {
    url: string;
    status: number;
    headers?: {
        [key: string]: string;
    };
    body?: string;
    data?: TData;
};
